/*
 * max9867.h -- MAX9867 ALSA SoC Audio driver
 *
 * Copyright 2008 Maxim Integrated Products
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#ifndef _MAX9867_H
#define _MAX9867_H

/* MAX9867 register space */

#define MAX9867_STAUS        0x00
#define MAX9867_JACKSTATUS   0x01
#define MAX9867_AUXHIGH      0x02
#define MAX9867_AUXLOW       0x03
#define MAX9867_INTEN        0x04
#define MAX9867_SYSCLK       0x05
#define MAX9867_AUDIOCLKHIGH 0x06
#define MAX9867_AUDIOCLKLOW  0x07
#define MAX9867_IFC1A        0x08
#define MAX9867_IFC1B        0x09
#define MAX9867_CODECFLTR    0x0a
#define MAX9867_DACGAIN      0x0b
#define MAX9867_DACLEVEL     0x0c
#define MAX9867_ADCLEVEL     0x0d
#define MAX9867_LEFTLINELVL  0x0e
#define MAX9867_RIGTHLINELVL 0x0f
#define MAX9867_LEFTVOL      0x10
#define MAX9867_RIGHTVOL     0x11
#define MAX9867_LEFTMICGAIN  0x12
#define MAX9867_RIGHTMICGAIN 0x13
#define MAX9867_INPUTCONFIG  0x14
#define MAX9867_MICCONFIG    0x15
#define MAX9867_MODECONFIG   0x16
#define MAX9867_PWRMAN       0x17
#define MAX9867_REVISION     0xff

#define MAX9867_CACHEREGNUM 	10

struct max9867_setup_data {
	unsigned short i2c_address;
};

//extern struct snd_soc_codec_dai max9867_dai;
extern struct snd_soc_dai_driver max9867_dai;
//extern struct snd_soc_codec_device soc_codec_dev_max9867;
extern struct snd_soc_codec_driver soc_codec_dev_max9867;

#endif
